from abc import ABC, abstractmethod
from typing import Union

import discord
from cpl_query.extension import List
from discord.ext.commands import Context


class MessageServiceABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    async def delete_messages(self, messages: List[discord.Message]): pass
    
    @abstractmethod
    async def delete_message(self, message: discord.Message): pass
    
    @abstractmethod
    async def send_channel_message(self, channel: discord.TextChannel, message: str): pass
    
    @abstractmethod
    async def send_dm_message(self, message: str, receiver: Union[discord.User, discord.Member]): pass
    
    @abstractmethod
    async def send_ctx_msg(self, ctx: Context, message: str, file: discord.File = None): pass
